import { Bytes } from '@cmdcode/buff-utils'

export type SignOptions = Partial<SignConfig>

export interface SignConfig {
  aux      ?: Bytes | null
  adaptor  ?: Bytes
  nonce    ?: Bytes
  recovery ?: Bytes
  tweak    ?: Bytes
  throws    : boolean
  xonly     : boolean
}

export interface MusignConfig {
  group_key   : Bytes
  nonce_coeff : Bytes
  key_tweaks  : Bytes[]
  int_tweaks ?: Bytes[]
  ext_tweaks ?: Bytes[]
  sec_nonce  ?: Bytes
}

const SIGN_DEFAULTS : SignConfig = {
  throws : false,
  xonly  : true
}

export function sign_config (
  config : SignOptions = {}
) : SignConfig {
  return { ...SIGN_DEFAULTS, ...config  }
}
